//
// C++ Interface: gmail
//
// Description: 
//
//
// Author: Stefano <stefano@xiaprojects.com>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef GMAIL_H
#define GMAIL_H

#include <qobject.h>

#include <qstring.h>
#include <qimage.h>
#include <qxml.h>
#include <qdom.h>
#include <qtimer.h>
#include "gpluginsdk.h"
#include <qpixmap.h>
#include <kiconloader.h>
#include <kdirwatch.h>
#include <kdirlister.h>

class QPixmap;
class gPluginPainter;


/**
@author Stefano
*/
class GTrash : public gPluginSDK
{
Q_OBJECT
public:
    GTrash(QObject *parent = 0, const char *name = 0);

    ~GTrash();

protected:
	//KDirWatch *KDEWatcher;
	KDirLister *mpDirLister;

	QString			incomingIcon;
	QPixmap			BasePixmap;
	QPixmap			IncomingPixmap;
	QString			TrashPath;
	int			iMiniText;

public slots:
    void xGetParameterList(QStringList *);
    void xPaint(int nEmails);
    void xApplyCfg();
    void xGetParameter(const QString, QString&);
    void xSetupParameter(const QString, const QString);
    void xStart();
    void xStop();
    void polling();
    void dirty(const QString &);
    void slotClear();
    void slotCompleted();
    void slotDeleteItem(KFileItem *);

protected:
    void loadImages();
};

#endif
